import type { FlightRouterState, FetchServerResponseResult } from '../../../server/app-render/types';
import { PrefetchKind } from './router-reducer-types';
export interface FetchServerResponseOptions {
    readonly flightRouterState: FlightRouterState;
    readonly nextUrl: string | null;
    readonly buildId: string;
    readonly prefetchKind?: PrefetchKind;
    readonly isHmrRefresh?: boolean;
}
/**
 * Fetch the flight data for the provided url. Takes in the current router state
 * to decide what to render server-side.
 */
export declare function fetchServerResponse(url: URL, options: FetchServerResponseOptions): Promise<FetchServerResponseResult>;
