// Share the instance module in the next-shared layer
import { requestAsyncStorage } from './request-async-storage-instance' with {
    'turbopack-transition': 'next-shared'
};
export { requestAsyncStorage };
export function getExpectedRequestStore(callingExpression) {
    const store = requestAsyncStorage.getStore();
    if (store) return store;
    throw new Error("`" + callingExpression + "` was called outside a request scope. Read more: https://nextjs.org/docs/messages/next-dynamic-api-wrong-context");
}

//# sourceMappingURL=request-async-storage.external.js.map