import { type RequestStore } from '../../client/components/request-async-storage.external';
import type { CacheScope } from './react-cache-scope';
import type { RequestLifecycleOpts } from '../base-server';
import type { AfterTask } from './after';
export type AfterContextOpts = {
    waitUntil: RequestLifecycleOpts['waitUntil'] | undefined;
    onClose: RequestLifecycleOpts['onClose'] | undefined;
    cacheScope: CacheScope | undefined;
};
export declare class AfterContext {
    private waitUntil;
    private onClose;
    private cacheScope;
    private requestStore;
    private runCallbacksOnClosePromise;
    private callbackQueue;
    constructor({ waitUntil, onClose, cacheScope }: AfterContextOpts);
    run<T>(requestStore: RequestStore, callback: () => T): T;
    after(task: AfterTask): void;
    private addCallback;
    private runCallbacksOnClose;
    private runCallbacks;
}
